package test;

import java.util.ArrayList;

import org.eclipse.persistence.exceptions.DescriptorException;
import org.eclipse.persistence.mappings.AttributeAccessor;

public class RSLAttributeAccessor extends AttributeAccessor {

    @Override
    public Object getAttributeValueFromObject(Object object) throws DescriptorException {
        ArrayList<ResourceStatusLocations> rslList = new ArrayList<ResourceStatusLocations>();
        Response resp = (Response) object;
        if (resp.rs == null) {
            return null;
        }
        for (int i=0; i<resp.rs.size(); i++) {
            rslList.add(new ResourceStatusLocations(resp.rs.get(i), resp.rl.get(i)));
        }
        return rslList;
    }

    @Override
    public void setAttributeValueInObject(Object object, Object value) throws DescriptorException {
        ArrayList<ResourceStatus> rsList = new ArrayList<ResourceStatus>();
        ArrayList<ResourceLocation> rlList = new ArrayList<ResourceLocation>();
        
        Response resp = (Response) object;
        ArrayList<ResourceStatusLocations> rslList = (ArrayList<ResourceStatusLocations>) value;
        for (ResourceStatusLocations rsls : rslList) {
            rsList.add(rsls.rs);
            rlList.add(rsls.rl);
        }
        resp.rs = rsList;
        resp.rl = rlList;
    }
    
    @Override
    public void initializeAttributes(Class descriptorClass) throws DescriptorException {
        // do nothing as the attribute doesn't really exist
    }
}